package excises;

import java.io.*;	// include Java's IO library

/**
 * FilePrinter application - displays the contents of the file or files passed on 
 * the command line to standard out.
 */
class FilePrinter {

  /**
   * Main entry point - display the contents of each file
   */
  public static void main(String[] args) {

    for (int f=0; f < args.length; f++) {
      displayFile(args[f]);
    }
   
  } // end of main method


  /**
   * Pretty print the contents of a file to the screen and handle any 
   * exceptions
   */
  private static void displayFile(String fileName) {
    
	System.out.println();
    System.out.println(fileName + ":");

    FileReader fileReader = null; 

    fileReader = new FileReader(fileName);
    int c;
    while ( (c = fileReader.read()) != -1) {
        System.out.print((char)c);
    }   
    fileReader.close(); 
               
  } // end of displayFile method
} // end of class


