import java.io.*;
class IbfDrive
{
  static final String COPYRIGHT = 
  "Copyright 2000-2002, Imperial Business Forms & JSR Systems.  See: www.JsrSys.com/copyright.";
  static final int    MAXSUM = 100;

  JsrSysout sysout    = new JsrSysout();
  JsrUtil   u         = new JsrUtil();
  JsrLineIn   input   = new JsrLineIn();
  JsrLineOut output   = new JsrLineOut();
  IbfExtract ibfExtract = new IbfExtract();
  IbfRP5196B ibfRP5196B = new IbfRP5196B();
  IbfRP5226  ibfRP5226  = new IbfRP5226();

  String tempLine     = "";
  String newMonth     = "";
  String progName     = "";
  String inputName    = "";
  String outputName   = "";
  File   thisFile;
  String[] summary    = new String[MAXSUM];
  int      iSum       = 0;
  String[] passParm;

    public static void main(String argv[])
    {
        IbfDrive IbfDrive = new IbfDrive();
        IbfDrive.run(argv);
    }
    
    public void run(String parm[])
    {
      
      if (parm.length >= 3)
        sysout.syslog(parm[2]);
      else
        sysout.syslog("IbfDriveLog.txt");
        
      sysout.setNoStop();
      sysout.display("IbfDrive--"+COPYRIGHT);
      sysout.display("IbfDrive--usage: "+"IbfDrive <Control Card input> <temp Control file> <log file>");
      sysout.display("IbfDrive--Begin: "+u.getDateTime());
      if (parm.length < 3)
      {
        sysout.display("IbfDrive--requires three parameters");
        System.exit(4);
      }
      input.setName(parm[0]);   // set name of input     Control Card file


      while (0 <= input.getNext())
      {
         tempLine = input.getLine();
         if (tempLine.length()  >= 8 &&
             tempLine.substring(0,6).equals("month="))
         {
            newMonth = tempLine.substring(6,8);
            input.getNext();
         }
           
         progName = input.getLine();
         input.getNext();
         inputName = input.getLine();
         input.getNext();
         outputName = input.getLine();
         input.getNext();
         output.setName(parm[1]);  // set name of temporary Control Card file
         tempLine = input.getLine();
         tempLine = u.replaceAll(tempLine,"$$",newMonth);
         output.setLine(tempLine); // write first CC record
         input.getNext();
         tempLine = input.getLine();
         tempLine = u.replaceAll(tempLine,"$$",newMonth);
         output.setLine(tempLine); // write second CC record
         output.close();
         input.getNext();  // read -------- separator line
         summary [iSum] = "Program: "+progName+" Input file: "+inputName;
         if (!progName.equals("IbfExtract")) summary [iSum] += " Output file: "+outputName;
         summary [iSum]+= ".";
         thisFile = new File(inputName);
         if (thisFile.isFile())
         {       
            sysout.display (summary[iSum]);
            iSum++;
         
            if (progName.equals("IbfExtract"))
            {
               sysout.display("Calling IbfExtract: "+ inputName);
               passParm = new String[] {inputName};
               ibfExtract.run(passParm);
            }
            if ( progName.equals("IbfRP5196B") || progName.equals("IbfRP5196") )
            {
               sysout.display("Calling IbfRP5196B: "+ parm[1]+ " " + inputName+ " " + outputName);
               passParm = new String[] {parm[1], inputName, outputName};
               ibfRP5196B.run(passParm);
            }
            if (progName.equals("IbfRP5226"))
            {
               sysout.display("Calling IbfRP5226: "+ parm[1]+ " " + inputName+ " " + outputName);
               passParm = new String[] {parm[1], inputName, outputName};
               ibfRP5226.run(passParm);
            }
         }
         else
         {
            summary [iSum] += "\r\n... Program not run because Input file: "+inputName+" is missing!!!";
            sysout.display (summary[iSum]);
            iSum++;
         }
      }
      sysout.display("IbfDrive----Summary of Operations:");
      for (int i=0; i < iSum; i++)
         sysout.display(summary[i]);
         
      sysout.display("IbfDrive----End: "+u.getDateTime());
        
    }
 
}